{ self, config, lib, pkgs, ... }:
let inherit (lib) fileContents;
in
{
  imports = [ ../../users/anish ];


  fonts = {
    fonts = with pkgs; [ powerline-fonts dejavu_fonts ];
    fontconfig.defaultFonts = {
      monospace = [ "DejaVu Sans Mono for Powerline" ];
      sansSerif = [ "DejaVu Sans" ];
    };
  };

  nix = {
    settings = {
      sandbox = true;
      trusted-users = [ "root" "@wheel" ];
      allowed-users = [ "@wheel" ];
      auto-optimise-store = true;
      system-features = [ "nixos-test" "benchmark" "big-parallel" "kvm" ];
      experimental-features = [ "nix-command" "flakes" ];
    };
    gc.automatic = true;
    optimise.automatic = true;
    extraOptions = ''
      min-free = 536870912
      keep-outputs = true
      keep-derivations = true
      fallback = true
    '';
  };

  environment.systemPackages = with pkgs; [
    pinentry_gnome
    cached-nix-shell
  ];

  # For rage encryption, all hosts need a ssh key pair
  services.openssh = {
    enable = true;
    openFirewall = lib.mkDefault false;
  };

  # programs.gnupg.agent.enable = true;
  # programs.gnupg.agent.pinentryFlavor = "curses";

  services.earlyoom.enable = true;
}
