{ pkgs, ... }:

{
  systemd.services.cal-alarms = {
    serviceConfig.Type = "simple";
    path = [
      pkgs.libnotify
      pkgs.dunst
      pkgs.khal
      pkgs.unixtools.column
      pkgs.diffutils
    ];
    startAt = "*08:00:00";
    script = builtins.readFile ./alarm.sh;
    serviceConfig = {
      User = "anish";
      Environment = "DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/1000/bus";
    };
  };
  systemd.timers.cal-alarms = {
    wantedBy = [ "timers.target" ];
    partOf = [ "cal-alarms.service" ];
    timerConfig.OnCalendar = [ "*:0/10" ];
  };
}
