{ config, pkgs, lib, ... }:
{
  services.dnsmasq.enable = true;
  services.dnsmasq.extraConfig = ''
    domain-needed
    no-resolv
    local=/lan/
    local=/moss/
    cache-size=5000
    addn-hosts=/etc/adblock.hosts 
  ''; # TODO find a way to make adblock hosts reproducible and updateable
  services.dnsmasq.servers = [ "45.90.30.49" "45.90.28.49" "1.1.1.1" "8.8.8.8" ];
  # TODO use this list in mossnet-hosts
  networking.hosts = {
    "192.168.1.240" = [
      "mossnet.lan"
      "links.mossnet.lan"
      "read.mossnet.lan"
      "stats.mossnet.lan"
      "music.mossnet.lan"
      "rss.mossnet.lan"
      "tasks.mossnet.lan"
      "file.mossnet.lan"
      "books.mossnet.lan"
      "fin.mossnet.lan"
      "paper.mossnet.lan"
      "cal.mossnet.lan"
      "archive.mossnet.lan"
    ];
    "192.168.1.226" = [
      "df-web.lan"
    ];
  };
  networking.firewall.allowedTCPPorts = [ 53 ];
  networking.firewall.allowedUDPPorts = [ 53 ];
}
