{ pkgs, config, lib, ... }:

{
  services.paperless = {
    enable = true;
    consumptionDirIsPublic = true;
    extraConfig.PAPERLESS_AUTO_LOGIN_USERNAME = "admin";
  };

  environment.systemPackages = [
    pkgs.beancount
  ];

  # TODO
  # This one doesn't have a start condition, so I'm manually triggering it
  # I'm not sure what the proper start condition is for it 
  systemd.services.fava = {
    path = [
      pkgs.fava
    ];
    before = [ "nginx.service" ];
    serviceConfig = {
      User = "anish";
      ExecStart = ''
        ${pkgs.fava}/bin/fava -p 29492 /home/anish/usr/finance/ledger.beancount
      '';
      Restart = "on-failure";
    };
  };

  services.nginx = {
    enable = true;
    virtualHosts."fin.mossnet.lan".locations."/" = {
      proxyPass = "http://localhost:29492";
    };
    virtualHosts."paper.mossnet.lan".locations."/" = {
      proxyPass = "http://localhost:28981";
    };
  };
}
