{ pkgs, lib, ... }:

{
  networking.firewall.allowedTCPPorts = [ 20 21 ];
  networking.firewall.allowedTCPPortRanges = [{ from = 51000; to = 51999; }];
  services.vsftpd = {
    enable = true;
    writeEnable = true;
    anonymousUser = true;
    anonymousUserNoPassword = true;
    anonymousUploadEnable = true;
    anonymousMkdirEnable = true;
    anonymousUserHome = "/home/ftp";
    extraConfig = ''
      pasv_enable=Yes
      pasv_min_port=51000
      pasv_max_port=51999
    '';
  };
}
