{ self, pkgs, lib, config, ... }:
{
  age.secrets.sealight-mod-password.file = "${self}/secrets/sealight-mod-password.age";
  age.secrets.sealight-mod-password.owner = "mjolnir";
  services.mjolnir = {
    enable = true;
    protectedRooms = [
      "https://matrix.to/#/#public:sealight.xyz"
      "https://matrix.to/#/#theFeed:sealight.xyz"
      "https://matrix.to/#/#control:sealight.xyz"
    ];
    managementRoom = "#control:sealight.xyz";
    homeserverUrl = "https://sealight.xyz";

    pantalaimon = {
      enable = true;
      username = "mod";
      passwordFile = "/run/agenix/sealight-mod-password";
      options.homeserver = config.services.mjolnir.homeserverUrl;
    };
  };
}
