{ pkgs, ... }:

{
  systemd.services.vdir-sync = {
    serviceConfig.Type = "oneshot";
    path = [
      pkgs.vdirsyncer
    ];
    script = ''
      vdirsyncer sync
    '';
    serviceConfig = {
      User = "anish";
    };
  };
  systemd.timers.vdir-sync = {
    wantedBy = [ "timers.target" ];
    partOf = [ "vdir-sync.service" ];
    timerConfig.OnCalendar = [ "hourly" ];
  };
}
