{ pkgs, lib, ... }:

{
  systemd.services.get-music-sync = {
    serviceConfig.Type = "oneshot";
    path = [
      pkgs.coreutils
      pkgs.rsync
    ];
    script = builtins.readFile ./get-music.sh;
    serviceConfig = {
      User = "anish";
    };
  };
  systemd.timers.get-music-timer = {
    wantedBy = [ "timers.target" ];
    partOf = [ "get-music-sync.service" ];
    timerConfig.OnCalendar = [ "daily" ];
  };
}
