{ config, pkgs, lib, ... }:

{
  # services.tailscale.enable = true;
  networking.firewall.allowedUDPPorts = [ 60990 ];
  age.secrets.curve-wg.file = "/etc/nixos/secrets/curve-wg.age";
  age.secrets.curve-wg.owner = "anish";

  networking.wireguard.interfaces = {
    # TODO need some kind of module here to configure curve & box from hosts or something 
    wg0 = {
      ips = [ "10.0.69.2/24" ];
      listenPort = 60990; # to match firewall allowedUDPPorts (without this wg uses random port numbers)

      privateKeyFile = "/run/agenix/curve-wg";
      peers = [
        # For a client configuration, one peer entry for the server will suffice.
        {
          publicKey = "c1J4p63rD3IlszugMZiki7UBV3YmDdqa3DU4UejXzAI=";
          allowedIPs = [ "10.0.69.0/24" ];
          # Set this to the server IP and port.
          endpoint = "69.61.38.225:60990"; # ToDo: route to endpoint not automatically configured https://wiki.archlinux.org/index.php/WireGuard#Loop_routing https://discourse.nixos.org/t/solved-minimal-firewall-setup-for-wireguard-client/7577

          # Send keepalives every 25 seconds. Important to keep NAT tables alive.
          persistentKeepalive = 25;
        }
      ];
    };
  };
}
